package vishnu.cluster;

import java.util.*;

public class SimMatrix
{
    
    public float[] matrix;
    

    public SimMatrix(float[][] KDMatrix, int limit, Distance simfunc){
	
	float iarray[];
	
	int hitDocs = KDMatrix.length;
	int wordCount = KDMatrix[0].length;
	int index = 0;
	
	// to exclude diagonal and conjugates
	// - - - - -
	//         |
	// *       |
	// * *     |
	// * * *   |    
	
	int realSize = (hitDocs * (hitDocs - 1)/2);
	matrix = new float[realSize];
	
	// this gets the sim matrix for all docs rather 
	// than only the first limit - mistake?

	for(int i = 1; i < hitDocs; i++){
	    iarray = KDMatrix[i];
	    for(int j = 0; j < i; j++){
		matrix[index] = simfunc.get(iarray,KDMatrix[j]);
	        index++;
	    }
	}
    }

    public void printMatrix()
    {
	int countA = 0;
	int countB = 0;

	for( int i = 0; i < matrix.length; i++ ){
	    System.out.print(matrix[i] + " ");
	    if( countA >= countB ){
		System.out.println();
		countB++;
		countA = 0;
	    }
	    else countA++;
	}
    }
}














